/*
 * ProiectPM.c
 *
 * Created: 19.05.2017 13:49:55
 * Author : PetrutGrigore
 */ 

#include <avr/io.h>
#include <util/delay.h>

/* Functie ce activeaza convertorul analogic
- digital */

void ADC_init(void)
{
	ADMUX = (1 << REFS0);
	ADCSRA = (1 << ADEN) | (5 << ADPS0);
}

/* Functie ce obtine datele din convertorul
analogic-digital */

int ADC_get(uint8_t channel)
{
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;
	ADCSRA |= (1 << ADSC);

	while(ADCSRA & (1 << ADSC));
	return ADC;

	(void)channel;
	return 0;
}

int main(void)
{

	// setare pini ca iesire pentru LED-uri
	DDRC |= (1 << PC0);
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC2);

	// stingere initiala LED-uri
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC2);
	_delay_ms(10000);

	/* program de testare LED-uri; pentru testare
	se aprind LED-urile in ordinea Verde, Albastru, Rosu
	Verde + Albastru, Verde + Rosu, Albastru + Rosu, 
	Verde + Albastru + Rosu */

	// verde
	PORTC &= ~(1 << PC0);
	_delay_ms(10000);
	PORTC |= (1 << PC0);
	_delay_ms(10000);

	// albastru
	PORTC &= ~(1 << PC1);
	_delay_ms(10000);
	PORTC |= (1 << PC1);
	_delay_ms(10000);

	// rosu
	PORTC &= ~(1 << PC2);
	_delay_ms(10000);
	PORTC |= (1 << PC2);
	_delay_ms(10000);

	// verde + albastru
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC1);
	_delay_ms(10000);
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC1);
	_delay_ms(10000);

	// verde + rosu
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC2);
	_delay_ms(10000);
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC2);
	_delay_ms(10000);

	// albastru + rosu
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	_delay_ms(10000);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC2);
	_delay_ms(10000);

	// verde + rosu + albastru
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	_delay_ms(10000);
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC2);
	_delay_ms(10000);

	ADC_init();

	/* Am incercat sa ghicesc valorile date de accelerometru, pentru
	ca nu am reusit sa le citesc. Din teste, se pare ca am reusit sa ghicesc
	valoarea pentru y */
	
	while (1) 
    	{
		double x, y, z;
		z = ADC_get(0);
		y = ADC_get(1);
		x = ADC_get(2);

		if (x - 375 >= 15 && y - 375 >= 15 && z - 375 >= 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC0);
			PORTC &= ~(1 << PC1);
			PORTC &= ~(1 << PC2);
		}

		if (x - 375 >= 15 && y - 375 >= 15 && z - 375 < 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC0);
			PORTC &= ~(1 << PC1);
		}

		if (x - 375 >= 15 && y - 375 < 15 && z - 375 >= 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC0);
			PORTC &= ~(1 << PC2);
		}

		if (x - 375 >= 15 && y - 375 < 15 && z - 375 < 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC0);
		}

		if (x - 375 < 15 && y - 375 >= 15 && z - 375 >= 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC1);
			PORTC &= ~(1 << PC2);
		}

		if (x - 375 < 15 && y - 375 < 15 && z - 375 >= 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC2);
		}

		if (x - 375 < 15 && y - 375 >= 15 && z - 375 < 15) {
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC &= ~(1 << PC1);
		}

		if (x - 375 < 15 && y - 375 < 15 && z - 375 < 15) {
				PORTC |= (1 << PC0);
				PORTC |= (1 << PC1);
				PORTC |= (1 << PC2);
		}

		_delay_ms(2500);
	}
}

